Imports System.Math
Public Class SIO
    'ԗփGR[_@M
    Shared Sub stop_moving()
        Dim buff(64) As Byte

        'R}hM
        SIO.write_command("0")
    End Sub
    'ړJn
    Shared Sub start_moving(ByVal touch_abort As Integer, ByVal dist_move As Integer, ByVal steering As Integer, ByVal power As Integer)
        'ϐ`
        Dim buff(64) As Byte

        '
        SIO.write_command("1")

        '^b`ZTŃA{[g邩H
        'OF@PFA{[g
        SIO.write_char(touch_abort)

        'ړɑGR[_̃JEgî̂ł͂Ȃ̂ŒӁj
        SIO.write_char(dist_move)

        'XeAOpqbT[{֏o͂ovlpX̕
        SIO.write_int(steering)

        'ړp[^[𐧌䂷drbiXs[hRg[j֏o͂ovlpX̕
        SIO.write_int(power)

    End Sub

    'ԗփGR[_񓙁@M
    Shared Sub read_wheel(ByRef flg_running As Integer, ByRef count As Integer)
        Dim buff(64) As Byte

        'R}hM
        SIO.write_command("6")

        'Ԃl҂
        'MmF҂ƃG[
        Try
            Do
                'timing loop
                System.Windows.Forms.Application.DoEvents()
            Loop While frmMain.SerialPort1.BytesToRead < 2

            frmMain.SerialPort1.Read(buff, 0, 2)
            'f[^̕\()
            flg_running = buff(0)
            count = buff(1)

        Catch ex As TimeoutException
            'MsgBox("ʐMG[łB{bgK莞Ԉȓɉ܂")
        End Try

    End Sub

    'ԊOZT@M
    Shared Sub read_PSD(ByRef right_dist As Integer, ByRef left_dist As Integer)
        Dim buff(64) As Byte

        'R}hM
        SIO.write_command("7")

        'Ԃl҂
        'MmF҂ƃG[
        Try
            Do
                'timing loop
                System.Windows.Forms.Application.DoEvents()
            Loop While frmMain.SerialPort1.BytesToRead < 2

            frmMain.SerialPort1.Read(buff, 0, 2)
            'f[^̕\(Roll)
            PSD_raw2mm(buff(0), right_dist)

            'f[^̕\(Yaw)
            PSD_raw2mm(buff(1), left_dist)

        Catch ex As TimeoutException
            'MsgBox("ʐMG[łB{bgK莞Ԉȓɉ܂")
        End Try
    End Sub

    'dist_m :   [gPʂ̑茋
    Shared Sub get_sonic_dist(ByRef dist_m As Double)
        Dim buff(64) As Byte

        'R}hM
        SIO.write_command("d")

        'Ԃl҂
        'MmF҂ƃG[
        Try
            Do
                'timing loop
                System.Windows.Forms.Application.DoEvents()
            Loop While frmMain.SerialPort1.BytesToRead < 2

            frmMain.SerialPort1.Read(buff, 0, 2)
            '
            dist_m = buff(0) * 256 + buff(1)
            dist_m = dist_m * 1 / (16000000.0 / 8) '}CR̃NbNJE^̒lbɊZiH8/3664@16MHzzj
            'dist_m = dist_m * 1 / (24000000.0 / 12 / 12) '}CR̃NbNJE^̒lbɊZiPSoC@24MHzzj
            dist_m = dist_m / 0.000147 * 0.0254

            'pX̃JEglPʂ̒lɊZ
            'dist_m = dist_m * (331.5 + 0.6 * Val(frmMain.txtTmpature.Text)) / 2
        Catch ex As TimeoutException
            'MsgBox("ʐMG[łB{bgK莞Ԉȓɉ܂")
        End Try
    End Sub

    'T[~X^̓͒l擾
    Shared Sub read_thrmo(ByRef tempature As Double)

        Dim raw_data As Integer
        Dim buff(64) As Byte

        Dim sensor_table As utils1.SensorTable
        sensor_table.sensor_table = New Double(64, 1) {}

        'R}hM
        SIO.write_command("j")

        'Ԃl҂
        'MmF҂ƃG[
        Try
            Do
                'timing loop
                System.Windows.Forms.Application.DoEvents()
            Loop While frmMain.SerialPort1.BytesToRead < 2

            frmMain.SerialPort1.Read(buff, 0, 2)
            'f[^̕\()
            raw_data = buff(0) * 256 + buff(1)

            'f[^xɊZ
            utils1.ReadTable(sensor_table, "sensor_table.csv")
            tempature = utils1.Hokan(sensor_table, raw_data)

        Catch ex As TimeoutException
            'MsgBox("ʐMG[łB{bgK莞Ԉȓɉ܂")
        End Try

    End Sub

    'qbT[{@ʒu񑗐M
    Shared Sub move_servo(ByRef new_data() As Integer, ByRef last_data() As Integer)
        'ϐ`
        Dim i As Integer
        Dim err_msg As String

        'eLXg{bNX̐lő^ŏ͈͂ɂ邩`FbN
        For i = 0 To 7
            If new_data(i) < Values.servo_min Or new_data(i) > Values.servo_max Then
                err_msg = Format(i) + "ԃT[{̏o͒l͈ ("
                err_msg = err_msg + Format(Values.servo_min) + "`" + Format(Values.servo_max) + ") 𒴂Ă܂Bo͂킹܂B"
                MsgBox(err_msg, MsgBoxStyle.OkOnly, )
                Exit Sub
            End If
        Next

        'ԂȂ
        SIO.write_command("B")
        For i = 0 To 7
            SIO.write_int(Format(new_data(i)))
            last_data(i) = new_data(i)
        Next

    End Sub

    'qbT[{@ʒu񑗐M(Ԃj
    Shared Sub move_servo(ByRef point_num_i As Integer, ByRef new_data() As Integer, ByRef last_data() As Integer)
        'ϐ`
        Dim i, j, k As Integer
        Dim err_msg As String

        'eLXg{bNX̐lő^ŏ͈͂ɂ邩`FbN
        For i = 0 To 7
            If new_data(i) < Values.servo_min Or new_data(i) > Values.servo_max Then
                err_msg = Format(i) + "ԃT[{̏o͒l͈ ("
                err_msg = err_msg + Format(Values.servo_min) + "`" + Format(Values.servo_max) + ") 𒴂Ă܂Bo͂킹܂B"
                MsgBox(err_msg, MsgBoxStyle.OkOnly, )
                Exit Sub
            End If
        Next

        '}CRɂqbT[{M@ԕύXR}h𑗐M
        If point_num_i = 0 Then
            'ԂȂ
            SIO.write_command("B")
            For i = 0 To 7
                SIO.write_int(Format(new_data(i)))
                last_data(i) = new_data(i)
            Next
        Else
            '*********************************************

            'ԃ|Cg擾
            If point_num_i > 255 Then point_num_i = 255
            If point_num_i < 0 Then point_num_i = 0

            Dim coo(1024, 1), p_num, length As Double
            Dim motion_data_playing(1024, 7) As Integer
            '*********************************************
            'ԗL̃f[^
            For i = 0 To 7
                motion_data_playing(0, i) = last_data(i)
                length = new_data(i) - last_data(i)
                p_num = orbit.number_line1b(coo, point_num_i, length)
                For j = 0 To p_num - 1
                    motion_data_playing(j, i) = motion_data_playing(0, i) + coo(j, 0)
                Next j
            Next i

            For k = 0 To p_num - 1

                SIO.write_command("B")
                For i = 0 To 7
                    SIO.write_int(motion_data_playing(k, i))
                Next i

            Next
            For i = 0 To 7
                last_data(i) = motion_data_playing(p_num - 1, i)
            Next i

        End If

    End Sub

    'xZT@M
    Shared Sub read_accel(ByRef X As Integer, ByRef Y As Integer, ByRef Z As Integer)
        Dim buff(64) As Byte

        'R}hM
        SIO.write_command("C")

        'Ԃl҂
        'MmF҂ƃG[
        Try
            Do
                'timing loop
                System.Windows.Forms.Application.DoEvents()
            Loop While frmMain.SerialPort1.BytesToRead < 6

            frmMain.SerialPort1.Read(buff, 0, 6)
            'f[^̕\(Y)
            Y = buff(0) * 256 + buff(1)

            'f[^̕\(X)
            X = buff(2) * 256 + buff(3)

            'f[^̕\(Z)
            Z = buff(4) * 256 + buff(5)

        Catch ex As TimeoutException
            'MsgBox("ʐMG[łB{bgK莞Ԉȓɉ܂")
        End Try
    End Sub

    'qbT[{@M@nm^nee
    'switch: "0" ~A@"1"@Jn
    Shared Sub switch_servo(ByRef switch As String)

        'ϐ`
        Dim command_char(64) As Byte
        '}CRɂqbT[{M@ԕύXR}h𑗐M
        SIO.write_command("K")
        'qbT[{M@Jn^~R}h𑗐M
        command_char(0) = Asc(switch)
        frmMain.SerialPort1.Write(command_char, 0, 1)

    End Sub

    '^b`ZT@M
    Shared Sub read_touch(ByRef status As Integer)
        Dim a As Integer
        Dim buff(64) As Byte

        'R}hM
        SIO.write_command("J")

        'Ԃl҂
        'MmF҂ƃG[
        Try
            Do
                'timing loop
                System.Windows.Forms.Application.DoEvents()
            Loop While frmMain.SerialPort1.BytesToRead < 1

            frmMain.SerialPort1.Read(buff, 0, 1)
            'f[^̕\()
            a = buff(0) - Asc("0")

            status = a

        Catch ex As TimeoutException
            'MsgBox("ʐMG[łB{bgK莞Ԉȓɉ܂")
        End Try
    End Sub

    '{bgR}hLN^[M********************
    Shared Sub write_command(ByVal command As Char)
        'ϐ`
        Dim command_char(64), buff(64) As Byte

        '}CRɃR}h𑗐M
        command_char(0) = Asc(command)
        frmMain.SerialPort1.Write(command_char, 0, 1)
        'MmF҂ƃG[
        Try
            Do
                'timing loop
                System.Windows.Forms.Application.DoEvents()
            Loop While frmMain.SerialPort1.BytesToRead < 1

            frmMain.SerialPort1.Read(buff, 0, 1)
        Catch ex As TimeoutException
            MsgBox("ʐMG[łB{bgK莞Ԉȓɉ܂")
            Exit Sub
        End Try
        If command_char(0) <> buff(0) Then
            MsgBox("ʐMG[łB{bgR}hɐ܂")
            Exit Sub
        End If
    End Sub
    '1oCg̐VA|[go͂i͐j********************
    Shared Sub write_char(ByVal data As Integer)
        'ϐ`
        Dim buff(64) As Byte

        buff(0) = data
        'VA|[go
        frmMain.SerialPort1.Write(buff, 0, 1)
    End Sub

    '1oCg̐VA|[g͂i͐j********************
    Shared Sub read_char(ByRef data As Integer)

        Dim buff(64) As Byte

        'Ԃl҂
        'MmF҂ƃG[
        Try
            Do
                'timing loop
                System.Windows.Forms.Application.DoEvents()
            Loop While frmMain.SerialPort1.BytesToRead < 1

            frmMain.SerialPort1.Read(buff, 0, 1)

            data = buff(0)

        Catch ex As TimeoutException
            'MsgBox("ʐMG[łB{bgK莞Ԉȓɉ܂")
        End Try

    End Sub

    'QoCg̐VA|[go͂i͕j********************
    Shared Sub write_int(ByVal input_str As String)
        'ϐ`
        Dim buff(64) As Byte
        Dim output_val As Integer

        'eLXg{bNX̕𐮐ɕϊ
        output_val = Val(input_str)
        'ϊ̏o͒lʃoCgƉʃoCgɕăobt@ɃZbg
        buff(0) = Int(output_val / 256)
        buff(1) = output_val - Int(output_val / 256) * 256
        'VA|[go
        frmMain.SerialPort1.Write(buff, 0, 2)
    End Sub

    'QoCg̐VA|[g͂i͐j********************
    Shared Sub read_int(ByRef data As Integer)

        Dim buff(64) As Byte

        'Ԃl҂
        'MmF҂ƃG[
        Try
            Do
                'timing loop
                System.Windows.Forms.Application.DoEvents()
            Loop While frmMain.SerialPort1.BytesToRead < 2

            frmMain.SerialPort1.Read(buff, 0, 2)

            data = buff(0) * 256 + buff(1)

        Catch ex As TimeoutException
            'MsgBox("ʐMG[łB{bgK莞Ԉȓɉ܂")
        End Try

    End Sub

    'PSD̂`cϊœlPʂɕϊ
    Shared Sub PSD_raw2mm(ByVal raw_data As Integer, ByRef mm_data As Integer)

        Dim workf, workf2 As Double

        workf = raw_data
        If raw_data > 15 Then
            'mm Zf[^
            If raw_data < 60 Then
                workf2 = -0.0001 * workf ^ 3 + 0.0292 * workf ^ 2 - 2.848 * workf + 111.63
            Else
                workf2 = -0.2082 * workf + 34.086
            End If
            mm_data = workf2 * 10
        Else
            'WI[o[̏ꍇ
            mm_data = 800
        End If
    End Sub
    '
    'PSD̂Pʐl`cϊœlɕϊi}CR̒ŔrɎg߂̐lj
    Shared Sub PSD_mm2raw(ByVal mm_data As Integer, ByRef raw_data As Integer)

        Dim diff, diff1, dist_work As Integer
        diff1 = 999
        For raw_work = 0 To 255

            SIO.PSD_raw2mm(raw_work, dist_work)
            diff = Abs(dist_work - mm_data)

            If diff <= diff1 Then
                raw_data = raw_work
                diff1 = diff
            Else
                Exit For
            End If

        Next raw_work

    End Sub
End Class
