﻿Public Class frmTDS01a

    '「リセット」ボタンの処理
    Private Sub btnReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReset.Click

        '変数定義
        Dim command_char(64), buff(64) As Byte

        'コマンド送信
        frmMain.SerialPort3.WriteLine("0F")
        '結果受信
        TextBox1.AppendText(frmMain.SerialPort3.ReadLine + vbCrLf)

    End Sub

    '「戻る」ボタンの処理
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Visible = False
    End Sub

    '「測定開始」ボタンの処理
    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click

        '変数定義
        Dim command_char(64), buff(64) As Byte

        'マイコンにコマンドを送信
        frmMain.SerialPort3.WriteLine("21")
        '結果受信
        TextBox1.AppendText(frmMain.SerialPort3.ReadLine + vbCrLf)

    End Sub

    '「測定終了」ボタンの処理
    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click

        '変数定義
        Dim command_char(64), buff(64) As Byte

        'マイコンにコマンドを送信
        frmMain.SerialPort3.WriteLine("23")
        '結果受信
        TextBox1.AppendText(frmMain.SerialPort3.ReadLine + vbCrLf)

    End Sub

    '「磁気測定」ボタンの処理
    Private Sub btnCapture_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCapture.Click

        '変数定義
        Dim command_char(64), buff(64) As Byte

        'マイコンにコマンドを送信
        frmMain.SerialPort3.WriteLine("0D83")
        '結果受信
        TextBox1.AppendText(frmMain.SerialPort3.ReadLine + vbCrLf)

    End Sub

    '「受信」ボタンの処理
    Private Sub btnReceive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReceive.Click

        '変数定義
        Dim command_char(64), buff(64) As Byte
        Dim work_s, v_s(3) As String
        Dim i As Integer
        Dim v(3) As Double

        'マイコンにコマンドを送信
        frmMain.SerialPort3.WriteLine("29")
        '結果受信
        work_s = frmMain.SerialPort3.ReadLine
        TextBox1.AppendText(work_s + vbCrLf)

        For i = 0 To 2
            v_s(i) = Mid(work_s, i * 4 + 1, 4)
            If Mid(v_s(i), 1) = "F" Then
                v(i) = -(&H10000 - Val("&h" + v_s(i))) / 10
            Else
                v(i) = Val("&h" + v_s(i)) / 10
            End If
            TextBox1.AppendText(Str(v(i)) + vbCrLf)
        Next


    End Sub

    '「条件設定」ボタンの処理
    Private Sub btnSetting_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetting.Click

        '変数定義
        Dim command_char(64), buff(64) As Byte

        'マイコンにコマンドを送信
        frmMain.SerialPort3.WriteLine("051027A60000")
        '結果受信
        TextBox1.AppendText(frmMain.SerialPort3.ReadLine + vbCrLf)

    End Sub

    Private Sub btnFconv_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFconv.Click

        Dim fname As String
        Dim work_s, v_s(3) As String
        Dim i As Integer
        Dim v(3) As Double

        fname = "magnet2.txt"

        FileOpen(1, fname, OpenMode.Input)

        Do While Not EOF(1)

            '*******************************
            work_s = LineInput(1)
            For i = 0 To 2
                v_s(i) = Mid(work_s, i * 4 + 1, 4)
                If Mid(v_s(i), 1) = "F" Then
                    v(i) = -(&H10000 - Val("&h" + v_s(i))) / 10
                Else
                    v(i) = Val("&h" + v_s(i)) / 10
                End If
                TextBox1.AppendText(Str(v(i)) + ",")
            Next
            TextBox1.AppendText(vbCrLf)

        Loop


    End Sub
End Class