﻿Public Class frmRemocon

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Visible = False
    End Sub


    Private Sub txtMoveChr_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtMoveChr.KeyDown

        'ステアリング関連パラメータ
        If frmJoint.chkTrimRun.Checked = True Then
            frmJoint.steering_unit = Val(frmJoint.txtTrimPtch.Text)
        Else
            frmJoint.steering_unit = 125
        End If

        If e.KeyCode = Keys.Up Then
            '前進加速**********************************
            If Values.joint_data_new(1) - frmJoint.accel_unit <= frmJoint.accel_newtral Then
                '中立よりも前進側の場合
                If Values.joint_data_new(1) - frmJoint.accel_unit >= frmJoint.accel_min Then
                    frmJoint.accel_notch = frmJoint.accel_notch + 1

                    Values.joint_data_new(1) = Values.joint_data_new(1) - frmJoint.accel_unit
                    Me.txtMoveChr.Text = "スピードアップ"
                End If
            Else
                frmJoint.accel_notch = frmJoint.accel_notch + 1

                Values.joint_data_new(1) = Values.joint_data_new(1) - frmJoint.back_plm
            End If
            frmJoint.TextBox2.Text = Format(Values.joint_data_new(1))
            SIO.move_servo(Values.joint_data_new, Values.joint_data_last)

        ElseIf e.KeyCode = Keys.Down Then
            '減速／後進**********************************
            If Values.joint_data_new(1) + frmJoint.accel_unit <= frmJoint.accel_newtral Then
                frmJoint.accel_notch = frmJoint.accel_notch - 1

                Values.joint_data_new(1) = Values.joint_data_new(1) + frmJoint.accel_unit
                Me.txtMoveChr.Text = "スピードダウン"
            ElseIf Values.joint_data_new(1) + frmJoint.accel_unit > frmJoint.accel_newtral And Values.joint_data_new(1) + frmJoint.back_plm <= frmJoint.accel_newtral + frmJoint.back_plm * 1 Then
                frmJoint.accel_notch = frmJoint.accel_notch - 1

                Values.joint_data_new(1) = Values.joint_data_new(1) + frmJoint.back_plm
                Me.txtMoveChr.Text = "ブレーキ／後進"
            End If
            frmJoint.TextBox2.Text = Format(Values.joint_data_new(1))
            SIO.move_servo(Values.joint_data_new, Values.joint_data_last)
        ElseIf e.KeyCode = Keys.Enter Then
            '停止**********************************
            Me.txtMoveChr.Text = "停止"

            frmJoint.accel_notch = 0
            frmJoint.steering_notch = 0

            'ハンドル中立
            Values.joint_data_new(0) = frmJoint.steering_newtral
            '停止
            Values.joint_data_new(1) = frmJoint.accel_newtral
            SIO.move_servo(Values.joint_data_new, Values.joint_data_last)

            frmJoint.TextBox1.Text = Format(Values.joint_data_new(0))
            frmJoint.TextBox2.Text = Format(Values.joint_data_new(1))

        ElseIf e.KeyCode = Keys.Left Then
            '左ステア**********************************
            If Val(frmJoint.TextBox1.Text) + frmJoint.steering_unit <= 2445 Then

                Values.joint_data_new(0) = Values.joint_data_new(0) + frmJoint.steering_unit
                frmJoint.TextBox1.Text = Format(Values.joint_data_new(0))
                SIO.move_servo(Values.joint_data_new, Values.joint_data_last)

                Me.txtMoveChr.Text = "ハンドル左"
                If frmJoint.chkTrimRun.Checked = False Then
                    frmJoint.steering_notch = frmJoint.steering_notch + 1
                Else
                    frmJoint.txtSteeringNewtral.Text = Format(Values.joint_data_new(0))
                    Values.joint_data_org(0) = Values.joint_data_new(0)
                    frmJoint.steering_newtral = Values.joint_data_new(0)
                End If
            Else
                Me.txtMoveChr.Text = "左Ｍａｘ"
            End If
        ElseIf e.KeyCode = Keys.Right Then
            '右ステア**********************************
            If Val(frmJoint.TextBox1.Text) - frmJoint.steering_unit >= 1045 Then
                Values.joint_data_new(0) = Values.joint_data_new(0) - frmJoint.steering_unit
                frmJoint.TextBox1.Text = Format(Values.joint_data_new(0))
                SIO.move_servo(Values.joint_data_new, Values.joint_data_last)

                Me.txtMoveChr.Text = "ハンドル右"
                If frmJoint.chkTrimRun.Checked = False Then
                    frmJoint.steering_notch = frmJoint.steering_notch - 1
                Else
                    frmJoint.txtSteeringNewtral.Text = Format(Values.joint_data_new(0))
                    Values.joint_data_org(0) = Values.joint_data_new(0)
                    frmJoint.steering_newtral = Values.joint_data_new(0)
                End If
            Else
                Me.txtMoveChr.Text = "右Ｍａｘ"
            End If
        End If

        e.Handled = True

        frmJoint.txtAccelNotch.Text = frmJoint.accel_notch
        frmJoint.txtSteeringNotch.Text = frmJoint.steering_notch

    End Sub
End Class