﻿Imports System.IO

Imports System.Text
Imports System.Threading
Imports System.Math

Imports System.Media

Public Class frmVision1

    Public left_src_fname, right_src_fname As String
    Public req_fname, report_fname, color_fname As String
    Public img_fname_left, img_fname_right As String
    Public img_fname_left_bin, img_fname_right_bin As String

    '
    Private Sub frmVision1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        'img_fname_left = "C:\Msdevstd\work\h11c_left.bmp"
        'img_fname_right = "C:\Msdevstd\work\h11c_right.bmp"

        'img_fname_left_bin = "C:\Msdevstd\work\h11c_left_bin.bmp"
        'img_fname_right_bin = "C:\Msdevstd\work\h11c_right_bin.bmp"

        img_fname_right = "C:\Msdevstd\work\h11c_left.bmp"
        img_fname_left = "C:\Msdevstd\work\h11c_right.bmp"

        img_fname_right_bin = "C:\Msdevstd\work\h11c_left_bin.bmp"
        img_fname_left_bin = "C:\Msdevstd\work\h11c_right_bin.bmp"

        req_fname = "C:\Msdevstd\work\req_file.dat"
        report_fname = "C:\Msdevstd\work\report.txt"
        color_fname = "C:\Msdevstd\work\h11c_color.dat"

        FileSystemWatcher1.Path = "C:\Msdevstd\work\"
        FileSystemWatcher1.Filter = "notify.txt"
        FileSystemWatcher1.EnableRaisingEvents = False
        FileSystemWatcher1.NotifyFilter = NotifyFilters.LastWrite

        If Values.v_swap_image = 1 Then chkSwapImage.Checked = True
        txtColor_th.Text = Format(Values.v_color_th)
        txtMin_dist.Text = Format(Values.v_min_dist)
        txtMax_dist.Text = Format(Values.v_max_dist)
        txtMin_pixnum.Text = Format(Values.v_min_pix_num)
        txtMax_pixnum.Text = Format(Values.v_max_pix_num)
        txtLeft_cam_id.Text = Format(Values.v_left_cam_id)

    End Sub

    '「閉じる」ボタンの処理
    Private Sub btnCloseWindow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCloseWindow.Click

        If chkSwapImage.Checked = True Then
            Values.v_swap_image = 1
        Else
            Values.v_swap_image = 0
        End If
        Values.v_color_th = Val(txtColor_th.Text)
        Values.v_min_dist = Val(txtMin_dist.Text)
        Values.v_max_dist = Val(txtMax_dist.Text)
        Values.v_min_pix_num = Val(txtMin_pixnum.Text)
        Values.v_max_pix_num = Val(txtMax_pixnum.Text)
        Values.v_left_cam_id = Val(txtLeft_cam_id.Text)

        Me.Visible = False
    End Sub

    '「撮影認識」ボタンの処理
    Private Sub btnCapture1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCapture1.Click

        Dim work_str, filename As String

        '変数初期化（取込ファイル名、リクエストファイル名など）
        If chkSwitchImage.Checked = True Then
            '２値化処理済みイメージを表示
            left_src_fname = img_fname_left_bin
            right_src_fname = img_fname_right_bin
        Else
            '生イメージを表示
            left_src_fname = img_fname_left
            right_src_fname = img_fname_right
        End If

        'リクエストファイル送信
        'リクエストファイルが無い場合、ファイルを作ってリクエスト
        'ある場合は、処理中か、もしくは相手プロセスが停止中
        'キャプチャ成功時は、相手プロセスにより消去される
        If Not IO.File.Exists(req_fname) Then
            FileOpen(11, req_fname, OpenMode.Output)
            PrintLine(11, "これはw7b.vb用のキャプチャリクエストファイルです。")

            work_str = "color_th," + txtColor_th.Text
            PrintLine(11, work_str)

            work_str = "min_dist," + txtMin_dist.Text
            PrintLine(11, work_str)

            work_str = "max_dist," + txtMax_dist.Text
            PrintLine(11, work_str)

            work_str = "min_pixnum," + txtMin_pixnum.Text
            PrintLine(11, work_str)

            work_str = "max_pixnum," + txtMax_pixnum.Text
            PrintLine(11, work_str)

            work_str = "left_cam_id," + txtLeft_cam_id.Text
            PrintLine(11, work_str)

            FileClose(11)
        Else
            MsgBox("処理中か若しくは前回処理がアボートしています。リクエストファイルを手動消去してください。")
            Exit Sub
        End If

        '前回撮影画像をリネームして保存
        Try
            If chkRenameFile.Checked = True Then
                'フィルがあるかチェック(左）
                If IO.File.Exists(img_fname_left) Then
                    'ファイルがあったらユニークファイル名作成
                    filename = ""
                    utils1.get_unique_fname(filename, "_w7b_L.bmp")
                    filename = FileSystemWatcher1.Path + filename
                    'ファイルをリネーム
                    IO.File.Move(img_fname_left, filename)
                End If
                '(右）
                If IO.File.Exists(img_fname_right) Then
                    'ファイルがあったらユニークファイル名作成
                    filename = ""
                    utils1.get_unique_fname(filename, "_w7b_R.bmp")
                    filename = FileSystemWatcher1.Path + filename
                    'ファイルをリネーム
                    IO.File.Move(img_fname_right, filename)
                End If

                'フィルがあるかチェック(左）
                If IO.File.Exists(img_fname_left_bin) Then
                    'ファイルがあったらユニークファイル名作成
                    filename = ""
                    utils1.get_unique_fname(filename, "_w7b_L_bin.bmp")
                    filename = FileSystemWatcher1.Path + filename
                    'ファイルをリネーム
                    IO.File.Move(img_fname_left_bin, filename)
                End If
                '(右）
                If IO.File.Exists(img_fname_right_bin) Then
                    'ファイルがあったらユニークファイル名作成
                    filename = ""
                    utils1.get_unique_fname(filename, "_w7b_R_bin.bmp")
                    filename = FileSystemWatcher1.Path + filename
                    'ファイルをリネーム
                    IO.File.Move(img_fname_right_bin, filename)
                End If

            End If
        Catch ex As IOException
            MsgBox("イメージファイルのリネームでI/O Exceptionが発生しました。")
        End Try

        'System.Threading.Thread.Sleep(1000)
        'file system watcherセット
        FileSystemWatcher1.EnableRaisingEvents = True

    End Sub

    'キャプチャ＆ステレオ測定完了のファイルが出来た時の受け取り処理・・・「撮影認識」ボタンとペア
    Private Sub FileSystemWatcher1_Changed(ByVal sender As Object, ByVal e As System.IO.FileSystemEventArgs) Handles FileSystemWatcher1.Changed

        Dim fs_l, fs_r As FileStream
        Dim image_l, image_r As Image

        FileSystemWatcher1.EnableRaisingEvents = False

        '注意：Image.FromFileで表示すると、ＶＢが起動中ファイルにロックがかかり更新不可となってしまうので
        '　　　Streamを使う。ただし、Streamで表示したイメージはSaveメソッドが使えないので要検討
        fs_l = New FileStream(left_src_fname, FileMode.Open, FileAccess.Read)
        image_l = System.Drawing.Image.FromStream(fs_l)
        fs_l.Close()

        fs_r = New FileStream(right_src_fname, FileMode.Open, FileAccess.Read)
        image_r = System.Drawing.Image.FromStream(fs_r)
        fs_r.Close()

        picLeftCam.Image = image_l
        picRightCam.Image = image_r

        picLeftCam.Refresh()
        picRightCam.Refresh()

        draw_objects(report_fname)

    End Sub

    'レーダーチャートを描く******************************************
    '引数
    Private Sub draw_objects(ByVal filename As String)
        '変数定義
        Dim xs1, ys1, xe1, ye1, x, y, z, base_x, base_y As Integer
        Dim magni As Double

        Dim myPen As New Pen(Color.Indigo)
        Dim formGraphics As Graphics

        Dim work_str_arr() As String
        Dim work_str As String

        '座標原点の定義
        base_x = pictRader.Size.Width * 0.5
        base_y = pictRader.Size.Height * 0.9

        '描画倍率の定義（PictureBoxの高さを5000mmと対応させる）
        magni = pictRader.Size.Height / 5000

        pictRader.Refresh()
        formGraphics = pictRader.CreateGraphics()

        '座標軸を描く
        myPen.Color = ColorTranslator.FromOle(RGB(0, 0, 0))
        'Ｘ軸
        ys1 = base_y
        ye1 = base_y
        myPen.Width = 2
        Do
            xs1 = 0
            xe1 = pictRader.Size.Width
            formGraphics.DrawLine(myPen, xs1, ys1, xe1, ye1)
            ys1 = ys1 - 500 * magni
            ye1 = ye1 - 500 * magni
            myPen.Width = 1
        Loop While ys1 > 0

        'Ｙ軸
        myPen.Width = 2
        xs1 = base_x
        ys1 = 0
        xe1 = base_x
        ye1 = base_y
        formGraphics.DrawLine(myPen, xs1, ys1, xe1, ye1)

        '測定結果を描く
        myPen.Color = ColorTranslator.FromOle(RGB(255, 0, 0))
        myPen.Width = 1

        Me.txtMessages.Clear()
        FileOpen(1, filename, OpenMode.Input)
        Do While Not EOF(1)

            work_str = LineInput(1)
            txtMessages.AppendText(work_str + vbCrLf)

            work_str_arr = work_str.Split(",")

            If work_str_arr(0) = "左イメージcog x_y" Then
                x = Val(work_str_arr(1))
                y = Val(work_str_arr(2))
            End If

            If work_str_arr(0) = "右イメージcog x_y" Then
                x = Val(work_str_arr(1))
                y = Val(work_str_arr(2))
            End If

            If work_str_arr(0) = "対象の位置情報　　x_y_z" Then
                x = Val(work_str_arr(1))
                y = Val(work_str_arr(2))
                z = Val(work_str_arr(3))

                xe1 = base_x - y * magni
                ye1 = base_y - x * magni
                formGraphics.DrawArc(myPen, xe1, ye1, 4, 4, 0, 360)
            End If

        Loop

        FileClose(1)

        '終了処理
        myPen.Dispose()
        formGraphics.Dispose()
    End Sub

    'レーダーチャートを描く******************************************
    '引数
    Private Sub draw_objects2(ByVal target_X As Double, ByVal target_Y As Double)
        '変数定義
        Dim xs1, ys1, xe1, ye1, x, y, z, base_x, base_y As Integer
        Dim magni As Double

        Dim myPen As New Pen(Color.Indigo)
        Dim formGraphics As Graphics

        '座標原点の定義
        base_x = pictRader.Size.Width * 0.5
        base_y = pictRader.Size.Height * 0.9

        '描画倍率の定義（PictureBoxの高さを6000mmと対応させる）
        magni = pictRader.Size.Height / 6000

        pictRader.Refresh()
        formGraphics = pictRader.CreateGraphics()

        '座標軸を描く
        myPen.Color = ColorTranslator.FromOle(RGB(0, 0, 0))
        'Ｘ軸
        xs1 = 0
        ys1 = base_y
        xe1 = pictRader.Size.Width
        ye1 = base_y
        formGraphics.DrawLine(myPen, xs1, ys1, xe1, ye1)

        'Ｙ軸
        xs1 = base_x
        ys1 = 0
        xe1 = base_x
        ye1 = base_y
        formGraphics.DrawLine(myPen, xs1, ys1, xe1, ye1)

        '測定結果を描く
        myPen.Color = ColorTranslator.FromOle(RGB(255, 0, 0))
        myPen.Width = 3

        xe1 = base_x - target_Y * magni
        ye1 = base_y - target_X * magni
        formGraphics.DrawArc(myPen, xe1, ye1, 4, 4, 0, 360)

        '終了処理
        myPen.Dispose()
        formGraphics.Dispose()
    End Sub

    'カラーサンプリングや確認用に、カメラで撮影したオリジナルのイメージをピクチャーボックスに表示する
    Private Sub btnImgFileRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnImgFileRead.Click
        Dim fs As FileStream
        Dim image As Image

        If IO.File.Exists(img_fname_left) Then
            fs = New FileStream(img_fname_left, FileMode.Open, FileAccess.Read)
            image = System.Drawing.Image.FromStream(fs)
            fs.Close()

            picLeftCam.Image = image
            left_src_fname = img_fname_left

        Else
            MsgBox("指定されたイメージファイルはありません")
        End If

        If IO.File.Exists(img_fname_right) Then
            fs = New FileStream(img_fname_right, FileMode.Open, FileAccess.Read)
            image = System.Drawing.Image.FromStream(fs)
            fs.Close()

            picRightCam.Image = image
            right_src_fname = img_fname_right
        Else
            MsgBox("指定されたイメージファイルはありません")
        End If

    End Sub

    'マウス指示で認識用の色をピクチャーボックスから拾うイベントハンドラ（左目用）
    Private Sub picLeftCam_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picLeftCam.MouseDown

        Dim X As Integer
        Dim Y As Integer
        Dim work_str As String
        Dim Pict1 As New Bitmap(Me.picLeftCam.Image)
        Dim PixelColor As Color

        '「色収集ＯＮ」チェックの時に処理
        work_str = ""
        If chkColorCollect.Checked = True Then
            X = picLeftCam.PointToClient(System.Windows.Forms.Cursor.Position).X
            Y = picLeftCam.PointToClient(System.Windows.Forms.Cursor.Position).Y

            PixelColor = Pict1.GetPixel(X, Y)

            Do
                If (Control.MouseButtons And MouseButtons.Left) = MouseButtons.Left Then Exit Do
                My.Application.DoEvents()
            Loop While 1 = 1

            work_str = "0,"
            work_str = work_str + Str(PixelColor.R) + ","
            work_str = work_str + Str(PixelColor.G) + ","
            work_str = work_str + Str(PixelColor.B) + vbCrLf

            pictColorSample.BackColor = PixelColor

            txtMessages.AppendText(work_str)

        End If

        '「ＲＯＩ取得ＯＮ」チェックの時に処理
        '面積的ステレオマッチングの処理対象エリアを左カメラ画像から取得する
        If chkChangeROI.Checked = True Then
            X = picLeftCam.PointToClient(System.Windows.Forms.Cursor.Position).X - values.ROI_width / 2
            Y = picLeftCam.PointToClient(System.Windows.Forms.Cursor.Position).Y - values.ROI_height / 2

            If X < 0 Then X = 0
            If Y < 0 Then Y = 0

            If X + values.ROI_width > picLeftCam.Width Then X = picLeftCam.Width - values.ROI_width - 1
            If Y + values.ROI_height > picLeftCam.Height Then Y = picLeftCam.Height - values.ROI_height - 1

            values.ROI_X = X
            values.ROI_Y = Y

            Do
                If (Control.MouseButtons And MouseButtons.Left) = MouseButtons.Left Then Exit Do
                My.Application.DoEvents()
            Loop While 1 = 1


            lblROI_XY.Text = X & ", " & Y

            'ＲＯＩ変更（小ウインドーへ対象エリアイメージをコピー）
            img1.ChangeROI_L(0)


            values.ROI_X_R = X + Val(txtDirectionOffset_X.Text)
            values.ROI_Y_R = Y + Val(txtDirectionOffset_Y.Text)
            img1.ChangeROI_R(0)

        End If

    End Sub

    'マウス指示で認識用の色をピクチャーボックスから拾うイベントハンドラ（右目用）
    Private Sub picRightCam_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picRightCam.MouseDown

        Dim X As Integer
        Dim Y As Integer
        Dim work_str As String
        Dim Pict1 As New Bitmap(Me.picRightCam.Image)
        Dim PixelColor As Color

        work_str = ""
        If chkColorCollect.Checked = True Then
            X = picRightCam.PointToClient(System.Windows.Forms.Cursor.Position).X
            Y = picRightCam.PointToClient(System.Windows.Forms.Cursor.Position).Y

            PixelColor = Pict1.GetPixel(X, Y)

            Do
                If (Control.MouseButtons And MouseButtons.Left) = MouseButtons.Left Then Exit Do
                My.Application.DoEvents()
            Loop While 1 = 1

            work_str = "1,"
            work_str = work_str + Str(PixelColor.R) + ","
            work_str = work_str + Str(PixelColor.G) + ","
            work_str = work_str + Str(PixelColor.B) + vbCrLf

            pictColorSample.BackColor = PixelColor

            txtMessages.AppendText(work_str)

        End If

    End Sub

    'テキストボックスをクリアする
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        txtMessages.Clear()
    End Sub

    '「保存」ボタンの処理（テキストボックスの内容をファイルへ保存する）
    Private Sub btnSaveText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveText.Click

        Dim fname As String

        If chkColorCollect.Checked = True Then

            SaveFileDialog1.InitialDirectory = "C:\Msdevstd\work"
            SaveFileDialog1.Filter = "All files (*.*)|*.*|dat files (*.dat)|*.dat"
            SaveFileDialog1.FilterIndex = 2
            SaveFileDialog1.RestoreDirectory = True
            SaveFileDialog1.ShowDialog()

            fname = SaveFileDialog1.FileName

            FileOpen(1, fname, OpenMode.Output)

            Print(1, txtMessages.Text)

            FileClose(1)
        End If
    End Sub

    Private Sub chkSwapImage_CheckStateChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkSwapImage.CheckStateChanged
        Dim work As String

        work = img_fname_left
        img_fname_left = img_fname_right
        img_fname_right = work

        work = img_fname_left_bin
        img_fname_left_bin = img_fname_right_bin
        img_fname_right_bin = work

    End Sub

    '「エリアマッチ測定」ボタンの処理（面積法のステレオマッチングでイメージ中央付近
    '（Ｙ＝２４０／２辺り）の距離を測る）
    Private Sub btnAreaMatch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAreaMatch.Click

        Dim i, j, k, data_num, min_ptr, start_x As Integer
        Dim diff_image(320), min_value As Long
        Dim target_X, target_Y, target_Z, min_dist, max_dist As Double
        Dim work_str As String

        min_dist = Val(txtMin_dist.Text)
        max_dist = Val(txtMax_dist.Text)

        If chkLineRecog.Checked = True Then

            FileOpen(1, Me.report_fname, OpenMode.Output)
            'For values.ROI_X = values.IMG_SIZE_H - 16 To 0 Step -4
            For values.ROI_X = values.IMG_SIZE_H - 16 To 16 * 3 Step -8

                values.ROI_Y_R = values.ROI_Y + Val(txtDirectionOffset_Y.Text)
                img1.ChangeROI_L(0)

                data_num = 0
                If values.ROI_X > values.IMG_SIZE_H - 16 * 4 Then
                    start_x = values.IMG_SIZE_H - 16 * 4
                Else
                    start_x = values.ROI_X
                End If

                For values.ROI_X_R = start_x + Val(txtDirectionOffset_X.Text) To 0 Step -1
                    img1.ChangeROI_R(0)
                    diff_image(data_num) = 0
                    For i = 0 To 255
                        For k = 0 To 2
                            diff_image(data_num) = diff_image(data_num) + Abs(values.vector_L(k, i) - values.vector_R(k, i))
                        Next
                    Next
                    data_num = data_num + 1
                Next

                min_ptr = -1
                min_value = 256 * 3 * 256
                For j = 0 To data_num - 1
                    If diff_image(j) < min_value Then
                        min_value = diff_image(j)
                        min_ptr = j
                    End If
                    PrintLine(1, Format(diff_image(j)))
                Next

                If min_ptr <> -1 Then
                    values.ROI_X_R = values.ROI_X - min_ptr + Val(txtDirectionOffset_X.Text)
                    img1.ChangeROI_R(0)

                    img1.get_coordinate(target_X, target_Y, target_Z)
                    If target_X > min_dist And target_X < max_dist Then
                        'txtMessages.AppendText("＜＜ステレオマッチング結果＞＞" + vbCrLf)
                        'txtMessages.AppendText("X = " + Format(target_X, "#####0.0") + ", Y =" + Format(target_Y, "#####0.0") + ", Z =" + Format(target_Z, "#####0.0") + vbCrLf)
                        work_str = "対象の位置情報　　x_y_z," + Format(target_X, "#####0.0") + "," + Format(target_Y, "#####0.0") + "," + Format(target_Z, "#####0.0")
                        PrintLine(1, work_str)
                        'draw_objects2(target_X, target_Y)
                    Else
                        txtMessages.AppendText("マッチ失敗" + vbCrLf)
                    End If
                End If

                'txtMessages.AppendText(vbCrLf + Format(min_value) + vbCrLf)

                My.Application.DoEvents()
            Next

            FileClose(1)

            draw_objects(report_fname)
        Else

            values.ROI_Y_R = values.ROI_Y + Val(txtDirectionOffset_Y.Text)
            img1.ChangeROI_L(0)

            data_num = 0
            If values.ROI_X > values.IMG_SIZE_H - 16 * 4 Then
                start_x = values.IMG_SIZE_H - 16 * 4
            Else
                start_x = values.ROI_X
            End If

            For values.ROI_X_R = start_x + Val(txtDirectionOffset_X.Text) To 0 Step -1
                img1.ChangeROI_R(0)
                diff_image(data_num) = 0
                For i = 0 To 255
                    For k = 0 To 2
                        diff_image(data_num) = diff_image(data_num) + Abs(values.vector_L(k, i) - values.vector_R(k, i))
                    Next
                Next
                data_num = data_num + 1
            Next

            min_ptr = -1
            min_value = 256 * 3 * 256
            For j = 0 To data_num - 1
                If diff_image(j) < min_value Then
                    min_value = diff_image(j)
                    min_ptr = j
                End If
            Next

            If min_ptr <> -1 Then
                values.ROI_X_R = values.ROI_X - min_ptr + Val(txtDirectionOffset_X.Text)
                img1.ChangeROI_R(0)

                img1.get_coordinate(target_X, target_Y, target_Z)
                If target_X > min_dist And target_X < max_dist Then
                    txtMessages.AppendText("＜＜ステレオマッチング結果＞＞" + vbCrLf)
                    txtMessages.AppendText("X = " + Format(target_X, "#####0.0") + ", Y =" + Format(target_Y, "#####0.0") + ", Z =" + Format(target_Z, "#####0.0") + vbCrLf)
                    draw_objects2(target_X, target_Y)
                Else
                    txtMessages.AppendText("マッチ失敗" + vbCrLf)
                End If
            End If

            txtMessages.AppendText(vbCrLf + Format(min_value) + vbCrLf)

            My.Application.DoEvents()
        End If

    End Sub

    '認識した対象まで走行する
    Private Sub btnRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRun.Click

        Dim x, y, z, dist0, dist1, target_x, target_y, turn_r, turn_q, end_of_arc(1), dist2go As Double
        Dim dist_run_puls, touch_abort, power_code As Integer
        Dim work_str, work_str_arr() As String

        If IO.File.Exists(report_fname) = False Then
            MsgBox("エラー！レポートファイルがありません。先に認識処理を行ってください。")
            Exit Sub
        End If

        If frmJoint.Visible = False Then
            MsgBox("先に「移動」フォームを表示してください")
            Exit Sub
        End If

        'シリアルポートが開いているかチェック
        If frmMain.SerialPort1.IsOpen = False Then
            MsgBox("先に「接続」して下さい")
            Exit Sub
        End If

        dist0 = 0
        dist1 = 999999

        '認識結果ファイル読取
        txtMessages.Clear()
        FileOpen(1, report_fname, OpenMode.Input)
        Do While Not EOF(1)

            work_str = LineInput(1)

            work_str_arr = work_str.Split(",")

            If work_str_arr(0) = "対象の位置情報　　x_y_z" Then
                x = Val(work_str_arr(1))
                y = Val(work_str_arr(2))
                z = Val(work_str_arr(3))

                '一番近い認識結果を選択する
                dist0 = (x ^ 2 + y ^ 2) ^ 0.5
                If dist0 < dist1 Then
                    dist1 = dist0
                    target_x = x / 1000
                    target_y = y / 1000
                    txtMessages.AppendText(work_str + vbCrLf)
                End If
            End If
        Loop

        FileClose(1)
        txtMessages.Update()

        turn_r = Values.turn_diameter_L2 / 2
        '旋回角度と直進距離を求める
        '2010/10/06・・・左右で旋回半径が異なる考慮追加→tyrn_rを配列変数化
        RoboIO_Move.go_coo1(target_x, target_y, turn_r, turn_q, end_of_arc, dist2go)

        '走行用のフォーム表示
        'frmJoint.Visible = True

        '課題：frmJoint等を経由せずとも動くようにする！

        touch_abort = 1
        power_code = 3
        System.Windows.Forms.Application.DoEvents()
        'ＥＲ０１を走らせる
        '旋回
        If Abs(turn_q) > PI / 80 Then
            RoboIO_Move.turn0(turn_q, power_code, touch_abort, dist_run_puls, True)
            frmGPSTest.wait_running() '走行完了を待つ
        End If

        '障害物を検知した場合の処理
        If frmJoint.flg_running <> 0 Then
            MsgBox("障害物を検出しました。走行を中断します。")
            Exit Sub
        End If

        System.Windows.Forms.Application.DoEvents()
        If dist2go > 3 Then
            dist2go = 3
        End If
        If dist2go >= 2 And dist2go < 3 Then
            dist2go = dist2go - 1
        End If

        '直進
        If dist2go <> 0.0 Then
            RoboIO_Move.go_foward(dist2go, power_code, touch_abort)
            frmGPSTest.wait_running() '走行完了を待つ
        End If

        '障害物を検知した場合の処理
        If frmJoint.flg_running <> 0 Then
            MsgBox("障害物を検出しました。走行を中断します。")
            Exit Sub
        End If

    End Sub
End Class